// COMplusObject.h : Declaration of the CCOMplusObject

#pragma once
#include "resource.h"       // main symbols
#include <comsvcs.h>

// ICOMplusObject
[
	object,
	uuid("0B03AB0B-6332-4A2E-A71A-688108DA643F"),
	dual,	helpstring("ICOMplusObject Interface"),
	pointer_default(unique)
]
__interface ICOMplusObject : IDispatch
{
	[id(1), helpstring("method Method1")] HRESULT Method1(void);
	[id(2), helpstring("method Method2")] HRESULT Method2([in] LONG p1, [out,retval] LONG* ret);
	[id(3), helpstring("method Method3")] HRESULT Method3([in] BSTR p1, [out,retval] BSTR* ret);
	[id(4), helpstring("method Method4")] HRESULT Method4([in] VARIANT p1, [out,retval] VARIANT* ret);
	[id(5), helpstring("method Method5")] HRESULT Method5([in] VARIANT p1, [out,retval] VARIANT* ret);
};


// CCOMplusObject

[
	coclass,
	threading("single"),
	aggregatable("never"),
	vi_progid("COMplus.COMplusObject"),
	progid("COMplus.COMplusObject.1"),
	version(1.0),
	uuid("FC6BF3B6-539C-4DF5-9F6A-4F435368E3F5"),
	helpstring("COMplusObject Class")
]
class ATL_NO_VTABLE CCOMplusObject : 
	public ICOMplusObject
{
public:
	CCOMplusObject()
	{
	}

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

// ICOMplusObject
public:
	STDMETHOD(Method1)(void);
	STDMETHOD(Method2)(LONG p1, LONG* ret);
	STDMETHOD(Method3)(BSTR p1, BSTR* ret);
	STDMETHOD(Method4)(VARIANT p1, VARIANT* ret);
	STDMETHOD(Method5)(VARIANT p1, VARIANT* ret);
};

