// COMplusPooledObject.cpp : Implementation of CCOMplusPooledObject

#include "stdafx.h"
#include "atlsafe.h"
#include "COMplusPooledObject.h"


// CCOMplusPooledObject

HRESULT CCOMplusPooledObject::Activate()
{
	HRESULT hr = GetObjectContext(&m_spObjectContext);
	if (SUCCEEDED(hr))
		return S_OK;
	return hr;
} 

BOOL CCOMplusPooledObject::CanBePooled()
{
	return TRUE;
} 

void CCOMplusPooledObject::Deactivate()
{
	m_spObjectContext.Release();
} 

STDMETHODIMP CCOMplusPooledObject::Method1(void)
{
	return S_OK;
}

STDMETHODIMP CCOMplusPooledObject::Method2(LONG p1,LONG* ret)
{
	*ret = p1;
	return S_OK;
}

STDMETHODIMP CCOMplusPooledObject::Method3(BSTR p1,BSTR* ret)
{
	return CComBSTR(p1).CopyTo(ret);
}

STDMETHODIMP CCOMplusPooledObject::Method4(VARIANT p1,VARIANT* ret)
{
	CComSafeArray<LONG> sa(p1.parray);
	return CComVariant(sa).Detach(ret);
}

STDMETHODIMP CCOMplusPooledObject::Method5(VARIANT p1,VARIANT* ret)
{
	CComSafeArray<BSTR> sa(p1.parray);
	return CComVariant(sa).Detach(ret);
}
