// COMplusPooledObject.h : Declaration of the CCOMplusPooledObject

#pragma once
#include "resource.h"       // main symbols
#include <comsvcs.h>

// ICOMplusPooledObject
[
	object,
	uuid("00EFAF79-2E5F-434A-A055-AE2331397D93"),
	dual,	helpstring("ICOMplusPooledObject Interface"),
	pointer_default(unique)
]
__interface ICOMplusPooledObject : IDispatch
{
	[id(1), helpstring("method Method1")] HRESULT Method1(void);
	[id(2), helpstring("method Method2")] HRESULT Method2([in] LONG p1, [out,retval] LONG* ret);
	[id(3), helpstring("method Method3")] HRESULT Method3([in] BSTR p1, [out,retval] BSTR* ret);
	[id(4), helpstring("method Method4")] HRESULT Method4([in] VARIANT p1, [out,retval] VARIANT* ret);
	[id(5), helpstring("method Method5")] HRESULT Method5([in] VARIANT p1, [out,retval] VARIANT* ret);
};


// CCOMplusPooledObject

[
	coclass,
	threading("free"),
	vi_progid("COMplus.COMplusPooledObject"),
	progid("COMplus.COMplusPooledObject.1"),
	version(1.0),
	uuid("5FFCA1DD-1C26-4777-9A32-B5239C79F068"),
	helpstring("COMplusPooledObject Class")
]
class ATL_NO_VTABLE CCOMplusPooledObject : 
	public IObjectControl,
	public ICOMplusPooledObject
{
public:
	CCOMplusPooledObject()
	{
	}

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

// IObjectControl
public:
	STDMETHOD(Activate)();
	STDMETHOD_(BOOL, CanBePooled)();
	STDMETHOD_(void, Deactivate)();

	CComPtr<IObjectContext> m_spObjectContext;

// ICOMplusPooledObject
public:
	STDMETHOD(Method1)(void);
	STDMETHOD(Method2)(LONG p1, LONG* ret);
	STDMETHOD(Method3)(BSTR p1, BSTR* ret);
	STDMETHOD(Method4)(VARIANT p1, VARIANT* ret);
	STDMETHOD(Method5)(VARIANT p1, VARIANT* ret);
};

