// DCOMObject.h : Declaration of the CDCOMObject

#pragma once
#include "resource.h"       // main symbols

// IDCOMObject
[
	object,
	uuid("EA7AB54A-9AD3-47C1-9B29-43923ADCFA25"),
	dual,	helpstring("IDCOMObject Interface"),
	pointer_default(unique)
]
__interface IDCOMObject : IDispatch
{
	[id(1), helpstring("method Method1")] HRESULT Method1(void);
	[id(2), helpstring("method Method2")] HRESULT Method2([in] LONG p1, [out,retval] LONG* ret);
	[id(3), helpstring("method Method3")] HRESULT Method3([in] BSTR p1, [out,retval] BSTR* ret);
	[id(4), helpstring("method Method4")] HRESULT Method4([in] VARIANT p1, [out,retval] VARIANT* ret);
	[id(5), helpstring("method Method5")] HRESULT Method5([in] VARIANT p1, [out,retval] VARIANT* ret);
};


// CDCOMObject
[
	coclass,
	threading("apartment"),
	vi_progid("DCOMtest.DCOMObject"),
	progid("DCOMtest.DCOMObject.1"),
	version(1.0),
	uuid("812B54F1-AFC2-4CFE-946D-5FD6A808256A"),
	helpstring("DCOMObject Class")
]
class ATL_NO_VTABLE CDCOMObject : 
	public IDCOMObject
{
public:
	CDCOMObject()
	{
	}

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:
	STDMETHOD(Method1)(void);
	STDMETHOD(Method2)(LONG p1, LONG* ret);
	STDMETHOD(Method3)(BSTR p1, BSTR* ret);
	STDMETHOD(Method4)(VARIANT p1, VARIANT* ret);
	STDMETHOD(Method5)(VARIANT p1, VARIANT* ret);
};

